use anyhow::{Context, Result};

#[tokio::main]
async fn main() -> Result<()> {
    tracing::subscriber::set_global_default(
        tracing_subscriber::fmt().with_env_filter("trace").finish(),
    )?;

    let mut ticker = swap::kraken::connect()
        .await
        .context("Failed to connect to kraken")?;

    loop {
        ticker.changed().await?;

        match &*ticker.borrow() {
            Ok(rate) => println!("Rate update: {}", rate),
            Err(e) => println!("Error: {:#}", e),
        }
    }
}
